var TMQZ = TMQZ || {};

// Define the PersonalityQuiz constructor
TMQZ.PersonalityQuiz = function(quizContainer) {
    TMQZ.Quiz.call(this, quizContainer);

    this.variant = "";
};

// Extend the Quiz class
TMQZ.PersonalityQuiz.prototype = Object.create(TMQZ.Quiz.prototype);
TMQZ.PersonalityQuiz.prototype.constructor = TMQZ.PersonalityQuiz;
TMQZ.PersonalityQuiz.prototype.parent = TMQZ.Quiz.prototype;

/* Define PersonalityQuiz methods */

TMQZ.PersonalityQuiz.prototype.getResult = function() {
    var quizObj = this;

    var sortedChoices = TMQZ.sortByFrequency(quizObj.choices);
    quizObj.variant = sortedChoices[0];

    for (var i = 0; i < quizObj.results.length; i++) {
        var result = quizObj.results[i];
        if( quizObj.variant == $(result).data('variant') ) {
            var resultText = $(result).find('.tmqz-result-text');
            resultText.html(quizObj.replaceTokens(resultText.html()));

            quizObj.assignSharingClicks(result);
            quizObj.bindRetry(result);

            return result;
        }
    }
};

TMQZ.PersonalityQuiz.prototype.replaceTokens = function(string) {
    var quizObj = this;

    string = quizObj.parent.replaceTokens.call(this, string);

    string = string.replace( '{%result%}', quizObj.variant );

    return string;
};

/* Define helper functions */

TMQZ.sortByFrequency = function(array) {
    var frequency = {};

    array.forEach(function(value) { frequency[value] = 0; });

    var uniques = array.filter(function(value) {
        return ++frequency[value] == 1;
    });

    return uniques.sort(function(a, b) {
        return frequency[b] - frequency[a];
    });
}
